%% by Joost de Winter <j.c.f.dewinter@tudelft.nl>, Pavlo Bazilinskyy <p.bazilinskyy@tudelft.nl>, Dimitra Dodou <d.dodou@tudelft.nl>
clear variables;close all;clc
FILENAME_s3='wp2_survey_results_no_ip4.xlsx'; % Measurement results
[~,~,raw]=xlsread(FILENAME_s3,'A3:CA3002'); % import Excel file with results from Survey 3. I added an extra line with IDs of columns for the ease of coding.
disp(['Number of respondents = ' num2str(size(raw,1))])
%% Instructions
temp=raw(:,29);X(:,67)=strcmp(temp,'No')+2*strcmp(temp,'Yes'); % Instructions understood
%% Basic information
temp=raw(:,63);X(:,1)=1*strcmp(temp,'Female')+2*strcmp(temp,'Male')-1*strcmp(temp,'I prefer not to respond'); % Gender
temp=raw(:,62);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,2)=NaN;else X(i,2)= cell2mat(temp(i));end;catch error;X(i,2)=NaN;end;end % Age
X(X(:,2)>110,2)=NaN; % People who report age greater than 110 years
temp=raw(:,27);for i=1:length(temp);try if strcmp(temp(i),'?');X(i,3)=NaN;else X(i,3)= cell2mat(temp(i));end;catch error;X(i,3)=NaN;end;end % Age of obtaining driver's license
X(X(:,3)>110,3)=NaN; % People who report licence more than 110 years
temp=raw(:,64);X(:,4)=1*strcmp(temp,'Private vehicle')+2*strcmp(temp,'Public transportation')+3*strcmp(temp,'Motorcycle')+4*strcmp(temp,'Walking/Cycling')+5*strcmp(temp,'Other')-1*strcmp(temp,'I prefer not to respond');  % Primary mode of transportation
temp=raw(:,53);X(:,5)=1*strcmp(temp,'Never')+2*strcmp(temp,'Less than once a month')+3*strcmp(temp,'Once a month to once a week')+4*strcmp(temp,'1 to 3 days a week')+5*strcmp(temp,'4 to 6 days a week')+6*strcmp(temp,'Every day')-1*strcmp(temp,'I prefer not to respond'); % How many times in past 12 months you drive a vehicle
temp=raw(:,26);for i=1:length(temp);try X(i,6)=1+cell2mat(temp(i));catch error;X(i,6)=1*strcmp(temp(i),'0 km / mi')+2*strcmp(temp(i),'1 - 1,000 km (1 - 621 mi)')+3*strcmp(temp(i),'1,001 - 5,000 km (622 - 3,107 mi)')+4*strcmp(temp(i),'5,001 - 15,000 km (3,108 - 9,321 mi)')+5*strcmp(temp(i),'15,001 - 20,000 km (9,322 - 12,427 mi)')+6*strcmp(temp(i),'20,001 - 25,000 km (12,428 - 15,534 mi)')+7*strcmp(temp(i),'25,001 - 35,000 km (15,535 - 21,748 mi)')+8*strcmp(temp(i),'35,001 - 50,000 km (21,749 - 31,069 mi)')+9*strcmp(temp(i),'50,001 - 100,000 km (31,070 - 62,137 mi)')+10*strcmp(temp(i),'More than 100,000 km (more than 62,137 mi)')-1*strcmp(temp(i),'I prefer not to respond');end;end % Mileage
temp=raw(:,30);for i=1:length(temp);try X(i,7)=1+cell2mat(temp(i));catch error;X(i,7)=7*strcmp(temp(i),'More than 5')-1*strcmp(temp(i),'I prefer not to respond');end;end % Number of accidents
temp=raw(:,9);Country=cell(size(X,1),1);for i=1:length(temp);try Country(i)=unique(temp(i));catch error;Country(i)={'NaN'};end;end % Country
% Driving behaviour DBQ
temp=raw(:,31:37);X(:,8:14)=1*strcmp(temp,'0 times per month')+2*strcmp(temp,'1 to 3 times per month')+3*strcmp(temp,'4 to 6 times per month')+4*strcmp(temp,'7 to 9 times per month')+5*strcmp(temp,'10 or more times per month')-1*strcmp(temp,'I prefer not to respond'); % DBQ violations
% Trust questions
temp=raw(:,76);X(:,16)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,77);X(:,17)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,47);X(:,18)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,46);X(:,19)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,28);X(:,20)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,49);X(:,21)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,52);X(:,22)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,51);X(:,23)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,38);X(:,24)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
%% Auditory questions
% Guessing recordings
temp=raw(:,65);X(:,25)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,66);X(:,26)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,67);X(:,27)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,68);X(:,28)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,69);X(:,29)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
% Questions on auditory warning messages
temp=raw(:,23);X(:,30)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,25);X(:,31)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,21);X(:,32)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,22);X(:,33)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,24);X(:,34)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,79);X(:,35)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,78);X(:,36)=1*strcmp(temp,'Female voice:')+2*strcmp(temp,'Male voice:')+3*strcmp(temp,'Beeps')+4*strcmp(temp,'Bell sound')+5*strcmp(temp,'Horn sound')-1*strcmp(temp,'I prefer not to respond')-2*strcmp(temp,'I did not hear the recording clearly');
temp=raw(:,55);X(:,37)=1*strcmp(temp,'A female voice is easier to understand in noisy environments')+2*strcmp(temp,'Such people drive mainly with men as passengers, and a female voice is easier to distinguish in the car')+3*strcmp(temp,'A female voice is more pleasant')+4*strcmp(temp,'A female voice is less commanding, and is easier to agree with it')+5*strcmp(temp,'Other')-1*strcmp(temp,'I prefer not to respond');
% Beeps
temp=raw(:,42);X(:,38)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,43);X(:,39)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,44);X(:,40)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,45);X(:,41)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
% Looming sounds
temp=raw(:,39);X(:,42)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,40);X(:,43)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,41);X(:,44)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
% sounds_are_a_good_way_to_get_my_attention_back_to_the_road
temp=raw(:,56);X(:,45)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond');
%% Visual questions
temp=raw(:,14);X(:,46)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % A take-over request should be provided by means of a green icon on the dashboard.
temp=raw(:,16);X(:,47)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % A take-over request should be provided by means of a strip of lights at the bottom of the windshield.
temp=raw(:,15);X(:,48)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % A take-over request should be provided by means of a head-up display with a green icon.
temp=raw(:,13);X(:,49)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % A take-over request should be provided by means of a brighter dashboard.
temp=raw(:,75);X(:,50)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % When I am not looking at the road for over 5 seconds, I would like the automation to take over control.
temp=raw(:,61);X(:,51)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % Visual messages are a good way to get my attention back to the road.
%% Vibration questions
temp=raw(:,19);X(:,52)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % a_takeover_request_should_be_provided_by_means_of_a_vibration_of_the_seat_back
temp=raw(:,18);X(:,53)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % a_takeover_request_should_be_provided_by_means_of_a_vibration_of_the_drivers_seat_pan
temp=raw(:,20);X(:,54)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % a_takeover_request_should_be_provided_by_means_of_a_vibration_of_the_seat_belt
temp=raw(:,17);X(:,55)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % a_takeover_request_should_be_provided_by_means_of_a_vibration_of_the__steering_wheel
temp=raw(:,60);X(:,56)=1*strcmp(temp,'Disagree strongly')+2*strcmp(temp,'Disagree a little')+3*strcmp(temp,'Neither agree nor disagree')+4*strcmp(temp,'Agree a little')+5*strcmp(temp,'Agree strongly')-1*strcmp(temp,'I prefer not to respond'); % vibrations are a good way to get my attention back to the road
%% Scenario 1 (construction works)
temp=raw(:,70);X(:,57)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,59);X(:,58)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
%% Scenario 2 (exiting the highway)
temp=raw(:,71);X(:,59)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
%% Scenario 3 (changing lanes)
temp=raw(:,72);X(:,60)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,57);X(:,61)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
%% Scenario 4 (automation failure)
temp=raw(:,73);X(:,62)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
%% Scenario 5 (traffic accident)
temp=raw(:,74);X(:,63)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
temp=raw(:,58);X(:,64)=1*strcmp(temp,'Sound message')+2*strcmp(temp,'Vibrations')+3*strcmp(temp,'Visual message')+4*strcmp(temp,'Sound message and vibrations (in any order)')+5*strcmp(temp,'Sound message and visual message (in any order)')+6*strcmp(temp,'Visual message and vibrations (in any order)')+7*strcmp(temp,'Sound message, visual message, and vibrations (in any order)')-1*strcmp(temp,'I prefer not to respond');
%% Year automated cars will be released
temp=raw(:,50);for i=1:length(temp);try if strcmp(temp(i),'?'); X(i,65)=NaN;else X(i,65)=cell2mat(temp(i));end;catch error;X(i,65)=NaN;end;end % Parse answers
%%
english_countries = {'ATG' 'AUS' 'BHS' 'BRB' 'BLZ' 'CAN' 'DMA' 'GRD' 'IRL' 'JAM' 'NZL' 'LCA' 'TTO' 'GBR' 'USA'};
UC=unique(Country); % unique countries
NC=NaN(length(UC),1);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(Country,UC(i)));
    NC(i)=length(temp);
end
CountryE=NaN(size(Country));
for i=1:size(X,1);
    if sum(strcmp(Country(i),english_countries))
        CountryE(i)=1;
    elseif sum(strcmp(Country(i),'NaN'))
    else CountryE(i)=0;
    end % check if the country i is an English speaking country
end
%% Survey time
try
    temp1=cell2mat(raw(:,2));temp2=cell2mat(raw(:,4));for i=1:length(temp1);try X(i,66)=24*3600*(datenum(temp1(i))-datenum(temp2(i)));catch error;X(i,66)=0;end;end
catch error
    for i=1:size(raw,1)
        X(i,66)=24*3600*(datenum(raw(i,2))-datenum(raw(i,4)));
    end
end
disp(['Survey time mean = ' num2str(mean(X(:,66)))]);
disp(['Survey time SD = ' num2str(std(X(:,66)))]);
disp(['Survey time Median = ' num2str(median(X(:,66)))]);
%% Filtering gathered data
X(X<=0)=NaN; % Put missing values (0) or no response (-1) at NaN
invalid1 = find(X(:,67)==1); % respondents who did not read instructions
invalid2 = find(X(:,2)<18);  % respondents who indicated they are under 18 years old
invalid3 = find(sum(isnan(X(:,[1:14 16:64 66:67])),2)>0);  % respondents who give 'I prefer not to respond' to one or more questions.
% Filter repondents who did not guess sounds correctly
invalid4 = find(X(:,25)~=2); % not male voice
invalid5 = find(X(:,26)~=1); % not female voice
invalid6 = find(X(:,27)~=4); % not bell sound
invalid7 = find(X(:,28)~=5); % not horn sound
invalid8 = find(X(:,29)~=3); % not beeps
invalid9 = find(isnan(CountryE)); % country unknown (possibly a faker)
X(:,15)=nanmean(X(:,8:14),2); % DBQ violations mean score across 7 items
invalid = unique([invalid1;invalid2;invalid3;invalid4;invalid5;invalid6;invalid7;invalid8;invalid9]); % Add together all invalid rows with data
for i=1:length(X(:,3)); if X(i,3)<14; X(i,3)=NaN;end;end
%% Show additional information
disp(['Number of respondents who did not read instructions = ' num2str(length(invalid1))])
disp(['Number of respondents under 18 = ' num2str(length(invalid2))])
disp(['Number of respondents with I prefer not to respond = ' num2str(length(invalid3))])
disp(['Wrong audio 1 = ' num2str(length(invalid4))])
disp(['Wrong audio 2 = ' num2str(length(invalid5))])
disp(['Wrong audio 3 = ' num2str(length(invalid6))])
disp(['Wrong audio 4 = ' num2str(length(invalid7))])
disp(['Wrong audio 5 = ' num2str(length(invalid8))])
disp(['Country unknown = ' num2str(length(invalid9))])
disp(['Number of respondents in any of these categories = ' num2str(length(invalid))])
disp(['Unique countries (all) = ' num2str(length(unique(Country)))])
X = X(:,1:66); % Remove unnessasary columns
X(invalid,:)=[]; % Remove invalid respondents
Country(invalid)=[]; % Remove invalid respondent
CountryE(invalid)=[]; % Remove invalid respondent
disp(['Respondents left after filtering = ' num2str(size(X))]);
disp(['Unique countries after filtering = ' num2str(length(unique(Country)))])
temp=find(X(:,65)<2014);
X(temp,65)=NaN;
disp(['Year automated cars will be released: answers that contained years in the past = ' num2str(length(temp))])
%% Load matlab file with required for analysis data
%load('tor_survey_data.mat');
%% Additional information to display
disp(['Male respondents = ' num2str(nansum(X(:,1)==2))])
disp(['Respondents driving every day = ' num2str(nansum(X(:,5)==6))])
disp(['Respondents using private vehicle as primary mode of transportation = ' num2str(nansum(X(:,4)==1))])
disp(['Respondents driving 4-6 days a week = ' num2str(nansum(X(:,5)==5))])
disp(['Respondents having between 1,001 and 5,000 km in the last 12 months = ' num2str(nansum(X(:,6)==3))])
disp(['Respondents having between 5,001 and 15,000 km in the last 12 months = ' num2str(nansum(X(:,6)==4))])
disp(['Sounds are a good way to get my attention back to the road (Q46)=  ' num2str(mean(X(:,45)))])
disp(['Visual messages are a good way to get my attention back to the road (Q52) = ' num2str(mean(X(:,51)))])
disp(['Vibrations are a good way to get my attention back to the road (Q57) = ' num2str(mean(X(:,56)))])
disp(['Male voice as the most urgent (Q35) = ' num2str(length(find(X(:,35)==2)))])
disp(['Female voice as the most urgent (Q35) = ' num2str(length(find(X(:,35)==1)))])
disp(['Horn as the most urgent (Q35) = ' num2str(length(find(X(:,35)==5)))])
disp(['Horn sound as the most annoying (Q36) = ' num2str(length(find(X(:,36)==5)))])
disp(['Beep urgency for long, medium, short and very short beeps (Q39-42) = ', num2str(nanmean(X(:,38:41)))])
disp(['Looming sounds urgency for 1 s, 2.5 s, and 5.0 s samples (Q43-45) = ', num2str(nanmean(X(:,42:44)))])
disp(['Female voice as best feedback. 1. Easier in noisy env. 2. Men as passengers 3. Pleasant 4. Less commanding 5. Other (Q37) = ', num2str([nansum(X(:,37)==1) nansum(X(:,37)==2) nansum(X(:,37)==3) nansum(X(:,37)==4) nansum(X(:,37)==5)])])
disp(['Female voice as best feedback (%) 1. Easier in noisy env. 2. Men as passengers 3. Pleasant 4. Less commanding 5. Other (Q37) = ', num2str(round(100/size(X,1)*[nansum(X(:,37)==1) nansum(X(:,37)==2) nansum(X(:,37)==3) nansum(X(:,37)==4) nansum(X(:,37)==5)]))])
disp(['Number of respondents - all three displays - Accident (Q64) = ' num2str(sum(X(:,63)==7))])
disp(['Number of respondents - all three displays - Failure (Q63) = ' num2str(sum(X(:,62)==7))])
disp(['Number of respondents - Sound - ExitHighway (Q60) = ' num2str(sum(X(:,59)==1))])
disp(['Number of respondents - Sound - ChangeLanes (Q61) = ' num2str(sum(X(:,60)==1))])
disp(['Number of respondents - Sound and vibrations - ConstWorks (Q58) = ' num2str(sum(X(:,57)==4))])
disp(['Number of respondents - Sound - ConstWorks (Q59) = ' num2str(sum(X(:,58)==1))])
disp(['Number of respondents - Sound - ChangeLanes (Q62) = ' num2str(sum(X(:,61)==1))])
disp(['Number of respondents - Sound - Accident (Q65) = ' num2str(sum(X(:,64)==1))])
disp(['Number of respondents - Sound and visual - ConstWorks (Q59) = ' num2str(sum(X(:,58)==5))])
disp(['Number of respondents - Sound and visual - ChangeLanes (Q62) = ' num2str(sum(X(:,61)==5))])
disp(['Number of respondents - Sound and visual - Accident (Q65) = ' num2str(sum(X(:,64)==5))])
%% Trust score
Trust=nanzscore(nanmean(nanzscore([X(:,19) X(:,21) X(:,22) X(:,23) X(:,24) 6-X( :,20)]),2));X(:,67) = Trust;
%% Descriptive statistics
Vars='Gender Age AgeLicense ModeTrans DriveFreq KmYear NrAcc Vangered Vmotorway Vresident Vfollowing Vrace Vhorn Vphone Vmean Trust1 Trust2 Trust3 Trust4 Trust5 Trust6 Trust7 Trust8 Trust9 Audio1 Audio2 Audio3 Audio4 Audio5 Audio6 Audio7 Audio8 Audio9 Audio10 Audio11 Audio12 Audio13 Beeps1 Beeps2 Beeps3 Beeps4 Looming1 Looming2 Looming3 Audio15 Visual1 Visual2 Visual3 Visual4 Visual5 Visual6 Tactile1 Tactile2 Tactile3 Tactile4 Tactile5 Scenario1a Scenario1b Scenario2 Scenario3a Scenario3b Scenario4 Scenario5a Scenario5b YearAuto SurvTime InstRead';
Labels='Mean Median SD Skewness Min Max N 1 2 3 4 5 6 7 8 9 10';
printmat([nanmean(X)' nanmedian(X)' nanstd(X)' skewness(X)' min(X)' max(X)' sum(isnan(X))' histc(X,1:10)'],'Descriptive statistics',Vars,Labels);
descriptive_stat = [nanmean(X)' nanmedian(X)' nanstd(X)' skewness(X)' min(X)' max(X)' sum(isnan(X))']; % Descriptive statistics saved as a variable
hist = histc(X,1:20)'; % Histogram counts saved as a variable
correlation_matrix = corr(X,'rows','pairwise','type','spearman'); % % Spearman correlation matrix
disp('Correlation matrix (at the level of respondents)')
disp(correlation_matrix([1:3 5:7 15 65:67  30:34 38:56],[1:3 5:7 15 65 66 67]));

%% Country analysis
one96=max(norminv([0.025, 0.975])); % 1.96
UC= unique(Country); % unique countries
UCall=UC;
NC=NaN(length(UC),1);
XC=NaN(length(UC),size(X,2));
TH=25; % threshold for respondents per country
XCCIlow=NaN(length(UC),67);
XCCIhigh=NaN(length(UC),67);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(Country,UC(i)));
    NC(i)=length(temp); % number of respondents per country
    XC(i,1:67)=nanmean(X(temp,:),1); % mean per country
    XCCIlow(i,1:67)=nanmean(X(temp,:),1)- one96*(nanstd(X(temp,:),1)/sqrt(size(X(temp,:),1))); % mean per country
    XCCIhigh(i,1:67)=nanmean(X(temp,:),1)+ one96*(nanstd(X(temp,:),1)/sqrt(size(X(temp,:),1))); % mean per country
end
UC=UC(NC>=TH)';
disp(['Respondents came from ' num2str(size(NC,1)) ' different countries'])
disp(['There were ' num2str(length(UC)) ' countries with 25 or more respondents'])
%% Country selection
NCm=NC(NC>=TH); % sample size per country
XCm=XC(NC>=TH,38:41);
XCCIlowm=XCCIlow(NC>=TH,38:41);
XCCIhighm=XCCIhigh(NC>=TH,38:41);
%% GNI per capita, from Data WorldBank
[GNI_ndata0,~,GNI_alldata]=xlsread('GNI_per_capita1.xlsx','B5:C223');
GNI_ndata=GNI_ndata0(:,1);GNI=NaN(length(UC),1);% data 2013
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(GNI_alldata(:,1),UC(i)));if ~isempty(temp);GNI(i,1)=GNI_ndata(temp,1);end
end

GNI_low=GNI_alldata(GNI_ndata0(:,1)<1026,:);
GNI_med=GNI_alldata(GNI_ndata0(:,1)>=1026&GNI_ndata0(:,1)<=12476,:);
GNI_high=GNI_alldata(GNI_ndata0(:,1)>12476,:);
%% Correlation matrix at the national level
correlation_matrix = corr([XC(NC>=TH,:) GNI],'rows','pairwise','type','spearman'); % % Spearman correlation matrix
Vars1='Gender Age AgeLicense DriveFreq KmYear NrAcc Vmean YearAuto SurvTime Trust Audio6 Audio7 Audio8 Audio9 Audio10 Beeps1 Beeps2 Beeps3 Beeps4 Looming1 Looming2 Looming3 Audio15 Visual1 Visual2 Visual3 Visual4 Visual5 Visual6 Tactile1 Tactile2 Tactile3 Tactile4 Tactile5 GNI';
Vars2='Gender Age AgeLicense DriveFreq KmYear NrAcc Vmean YearAuto SurvTime Trust GNI';
disp('Correlation matrix (at the national level)')
printmat(correlation_matrix([1:3 5:7 15 65:67  30:34 38:56 68],[1:3 5:7 15 65 66 67 68]),'Correlation_matrix',Vars1,Vars2);
%% Defining respondent subgroups depending on GNI per capita (level of respondents)
X_low=NaN(size(X,1),size(X,2)); X_med=X_low; X_high=X_low; Country_low=cell(size(Country)); Country_med=Country_low; Country_high=Country_low;
for i=1:length(Country) % loop over 1692 participants
    temp=find(strcmp(GNI_alldata(:,1),Country(i)));
    if isempty(temp)==1
        disp(Country(i))
    end
    if GNI_ndata0(temp)<1026 % low income
        X_low(i,:)=X(i,:);
        Country_low(i,:)=Country(i,:);
    elseif GNI_ndata0(temp)>=1026 && GNI_ndata0(temp)<=12476 % medium income
        X_med(i,:)=X(i,:);
        Country_med(i,:)=Country(i,:);
    elseif GNI_ndata0(temp)>12476 % high income
        X_high(i,:)=X(i,:);
        Country_high(i,:)=Country(i,:);
    end
end
X_low(isnan(X_low(:,1))==1,:)=[];
X_med(isnan(X_med(:,1))==1,:)=[];
X_high(isnan(X_high(:,1))==1,:)=[];%%
Country_low(cellfun('isempty',Country_low)) = [];
Country_med(cellfun('isempty',Country_med)) = [];
Country_high(cellfun('isempty',Country_high)) = [];
UC_low=unique(Country_low);
UC_med=unique(Country_med);
UC_high=unique(Country_high);
%% Country data displayed
[C1,C2]=sort(NCm,'descend');
disp('Countries with the largest number of respondents:')
disp([UC(C2(1)) num2str(C1(1))])
disp([UC(C2(2)) num2str(C1(2))])
disp([UC(C2(3)) num2str(C1(3))])
disp([UC(C2(4)) num2str(C1(4))])
disp([UC(C2(5)) num2str(C1(5))])
disp([UC(C2(6)) num2str(C1(6))])
disp([num2str(size(X_med,1)) ' respondents were located in middle-income countries (GNI per capita: $1,026$ 12,475)'])
disp([num2str(size(X_high,1)) ' respondents were located in high-income countries (GNI per capita: $12,475 or higher)'])
disp(['In the middle-income countries, ' num2str(100*nansum(X_med(:,1)==2)/size(X_med,1)) '% of the respondents were male'])
disp(['In the high-income countries, ' num2str(100*nansum(X_high(:,1)==2)/size(X_high,1)) '% of the respondents were male'])
%% Fisher's tests about gender differences (opinions of male vs. female respondents regarding male/female voice as warning display)
x1 = [[nansum(X(:,35)==1&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,35)==1&X(:,1)==1)] [nansum(X(:,35)==1&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,35)==1&X(:,1)==2)]];
[~,p1,stats1] = fishertest(x1);
disp(['Female voice most urgent: N = ' num2str(nansum(X(:,35)==1)) '; ' num2str(nansum(X(:,35)==1&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,35)==1&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p1)])
x2 = [[nansum(X(:,35)==2&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,35)==2&X(:,1)==1)] [nansum(X(:,35)==2&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,35)==1&X(:,1)==2)]];
[~,p2,stats2] = fishertest(x2);
disp(['Male voice most urgent: N = ' num2str(nansum(X(:,35)==2)) '; ' num2str(nansum(X(:,35)==2&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,35)==2&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p2)])
x3 = [[nansum(X(:,37)==3&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,37)==3&X(:,1)==1)] [nansum(X(:,37)==3&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,37)==3&X(:,1)==2)]];
[~,p3,stats3] = fishertest(x3);
disp(['Female voice is more pleasant: N = ' num2str(nansum(X(:,37)==3)) '; ' num2str(nansum(X(:,37)==3&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,37)==3&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p3)])
x4 = [[nansum(X(:,37)==4&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,37)==4&X(:,1)==1)] [nansum(X(:,37)==4&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,37)==4&X(:,1)==2)]];
[~,p4,stats4] = fishertest(x4);
disp(['Female voice is less commanding, and is easier to agree with it: N = ' num2str(nansum(X(:,37)==4)) '; ' num2str(nansum(X(:,37)==4&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,37)==4&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p4)])
x5 = [[nansum(X(:,37)==1&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,37)==1&X(:,1)==1)] [nansum(X(:,37)==1&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,37)==1&X(:,1)==2)]];
[~,p5,stats5] = fishertest(x5);
disp(['Female voice is easier to understand in noisy environments: N = ' num2str(nansum(X(:,37)==1)) '; ' num2str(nansum(X(:,37)==1&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,37)==1&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p5)])
x6 = [[nansum(X(:,37)==2&X(:,1)==1);nansum(X(:,1)==1)-nansum(X(:,37)==2&X(:,1)==1)] [nansum(X(:,37)==2&X(:,1)==2);nansum(X(:,1)==2)-nansum(X(:,37)==2&X(:,1)==2)]];
[~,p6,stats6] = fishertest(x6);
disp(['Such people drive mainly with men as passengers, and a female voice is easier to distinguish in the car: N = ' num2str(nansum(X(:,37)==2)) '; ' num2str(nansum(X(:,37)==2&X(:,1)==1)/nansum(X(:,1)==1)*100) ' % of the female respondents; ' num2str(nansum(X(:,37)==2&X(:,1)==2)/nansum(X(:,1)==2)*100) ' % of the male respondents; Male vs. female respondents: Fisher test p = ' num2str(p6)])
%% Colours for figures
c1 = [50 207 45] ./ 255; % green
c2 = [242 246 51] ./ 255;
c3 = [245 189 76] ./ 255; % orange
c4 = [252 126 4] ./ 255;
c5 = [239 31 28] ./ 255; % red
gc=[c1; c2; c3; c4; c5];
%% Preference to warning messages
figure('name','Figure 4','numbertitle','off');hold on
h1=barh(1:5, [nanmean(X_med(:,30:34)); nanmean(X_high(:,30:34))]','EdgeColor', gc(1,:),'FaceColor', gc(1,:),'LineWidth',1);
set(h1(1),'FaceColor',[1 1 1],'BarWidth',.6)
h2=barh(6:9, [nanmean(X_med(:,46:49)); nanmean(X_high(:,46:49))]','EdgeColor', gc(3,:),'FaceColor', gc(3,:),'LineWidth',1);
set(h2(1),'FaceColor',[1 1 1],'BarWidth',.6)
h3=barh(10:13, [nanmean(X_med(:,52:55)); nanmean(X_high(:,52:55))]','EdgeColor', gc(5,:),'FaceColor', gc(5,:),'LineWidth',1);
set(h3(1),'FaceColor',[1 1 1],'BarWidth',.6)
set(gca,'ytick',1:13);
set(gca,'yticklabel',{'Female voice','Male voice', 'Beeps', 'Bell sound', 'Horn sound', 'Green icon on the dashboard', 'Strip of lights at the bottom of the windshield', 'Head-up display with a green icon', 'Brighter dashboard', 'Vibration of the seat back','Vibration of the driver seat pan', 'Vibration of the seat belt', 'Vibration of the steering wheel'})
xlabel('Mean (1 = Disagree strongly, 5 = Agree strongly)','Fontsize',24,'Fontname','Arial')
set(gca','xlim',[2 4.1])
set(gca,'ydir','reverse')
set(gca,'YLim',[.5 13.5])
legend('Auditory, Middle-income countries', 'Auditory, High-income countries','Visual, Middle-income countries', 'Visual, High-income countries','Tactile, Middle-income countries','Tactile, High-income countries','Location','eastoutside')
j = 1; % plot 96% CI
for i=[30:34 46:49 52:55]
    plot([nanmean(X_med(:,i)) + one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1))), nanmean(X_med(:,i)) - one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1)))], [j-.15 j-.15],'k');
    plot([nanmean(X_med(:,i)) + one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1))) nanmean(X_med(:,i)) + one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1)))], [j+0.1-.15 j-0.1-.15],'k');
    plot([nanmean(X_med(:,i)) - one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1))) nanmean(X_med(:,i)) - one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1)))], [j+0.1-.15 j-0.1-.15],'k');
    plot([nanmean(X_high(:,i)) + one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1))), nanmean(X_high(:,i)) - one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1)))], [j+.15 j+.15],'k');
    plot([nanmean(X_high(:,i)) + one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1))) nanmean(X_high(:,i)) + one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1)))], [j+0.1+.15 j-0.1+.15],'k');
    plot([nanmean(X_high(:,i)) - one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1))) nanmean(X_high(:,i)) - one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1)))], [j+0.1+.15 j-0.1+.15],'k');
    j = j + 1;
end
j = 1;
for i=[30:34 46:49 52:55]
    str=sprintf('%1.2f',nanmean(X_med(:,i)));
    text(nanmean(X_med(:,i))+ one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1)))+ 0.05,j-.15,str,'fontsize',7,'fontname','arial')
    str=sprintf('%1.2f',nanmean(X_high(:,i)));
    text(nanmean(X_high(:,i))+ one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1)))+ 0.05,j+.15,str,'fontsize',7,'fontname','arial')
    j = j + 1;
end
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',7)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 8 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 4.png','-dpng','-r300','-painters');
%% Auditory warning messages: the most urgent and annoying message
temp=[histc(X_med(:,35),1:5)./size(X_med,1) histc(X_high(:,35),1:5)./size(X_high,1) histc(X_med(:,36),1:5)./size(X_med,1) histc(X_high(:,36),1:5)./size(X_high,1)];
figure('name','Figure 5','numbertitle','off');hold on
h=barh(temp);
set(gca,'ytick',1:5)
set(gca,'yticklabel',{'Female voice','Male voice', 'Beeps', 'Bell sound', 'Horn sound'})
xlabel('Proportion of respondents','Fontsize',28,'Fontname','Arial')
set(gca,'ydir','reverse')
legend('Most urgent, Middle-income countries','Most urgent, High-income countries', 'Most annoying, Middle-income countries','Most annoying, High-income countries','location','northeast')
Hist_med=NaN(10,length(UC_med)); Hist_high=NaN(10,length(UC_high));
for i=1:length(UC_med) % loop over 37 middle-income countries
    Hist_med(1:5,i)=histc(X_med(strcmp(Country_med,UC_med(i)),35),1:5);
    Hist_med(6:10,i)=histc(X_med(strcmp(Country_med,UC_med(i)),36),1:5);
end
for i=1:length(UC_high) % loop over 54 high-income countries
    Hist_high(1:5,i)=histc(X_high(strcmp(Country_high,UC_high(i)),35),1:5);
    Hist_high(6:10,i)=histc(X_high(strcmp(Country_high,UC_high(i)),36),1:5);
end

PCI_med=NaN(10,2);PCI_high=PCI_med;
for i=1:5
    [~, PCI_med(i,:)]=binofit(sum(Hist_med(i,:)),size(X_med,1));
    [~, PCI_high(i,:)]=binofit(sum(Hist_high(i,:)),size(X_high,1));
    [~, PCI_med(i+5,:)]=binofit(sum(Hist_med(i+5,:)),size(X_med,1));
    [~, PCI_high(i+5,:)]=binofit(sum(Hist_high(i+5,:)),size(X_high,1));
    plot([PCI_med(i,1) PCI_med(i,2)], [i-.27 i-.27]','k')
    plot([PCI_med(i,1) PCI_med(i,1)], [i-.27+.05 i-.27-.05]','k')
    plot([PCI_med(i,2) PCI_med(i,2)], [i-.27+.05 i-.27-.05]','k')
    str=sprintf('%1.2f',temp(i,1));
    text(PCI_med(i,2)+ 0.01,i-.27,str,'fontsize',7,'fontname','arial')
    
    plot([PCI_high(i,1) PCI_high(i,2)], [i-.09 i-.09]','k')
    plot([PCI_high(i,1) PCI_high(i,1)], [i-.09+.05 i-.09-.05]','k')
    plot([PCI_high(i,2) PCI_high(i,2)], [i-.09+.05 i-.09-.05]','k')
    str=sprintf('%1.2f',temp(i,2));
    text(PCI_high(i,2)+ 0.01,i-.09,str,'fontsize',7,'fontname','arial')
    
    plot([PCI_med(i+5,1) PCI_med(i+5,2)], [i+.09 i+.09]','k')
    plot([PCI_med(i+5,1) PCI_med(i+5,1)], [i+.09+.05 i+.09-.05]','k')
    plot([PCI_med(i+5,2) PCI_med(i+5,2)], [i+.09+.05 i+.09-.05]','k')
    str=sprintf('%1.2f',temp(i,3));
    text(PCI_med(i+5,2)+ 0.01,i+.09,str,'fontsize',7,'fontname','arial')
    
    plot([PCI_high(i+5,1) PCI_high(i+5,2)], [i+.27 i+.27]','k')
    plot([PCI_high(i+5,1) PCI_high(i+5,1)], [i+.27+.05 i+.27-.05]','k')
    plot([PCI_high(i+5,2) PCI_high(i+5,2)], [i+.27+.05 i+.27-.05]','k')
    str=sprintf('%1.2f',temp(i,4));
    text(PCI_high(i+5,2)+ 0.01,i+.27,str,'fontsize',7,'fontname','arial')
end

str=sprintf('%1.2f',nanmean(X_med(:,i)));
text(nanmean(X_med(:,i))+ one96*(nanstd(X_med(:,i))/sqrt(size(X_med,1)))+ 0.05,j-.15,str,'fontsize',7,'fontname','arial')
str=sprintf('%1.2f',nanmean(X_high(:,i)));
text(nanmean(X_high(:,i))+ one96*(nanstd(X_high(:,i))/sqrt(size(X_high,1)))+ 0.05,j+.15,str,'fontsize',7,'fontname','arial')
j = j + 1;

set(h,'BarWidth',.7,'LineWidth',1)
set(h(1),'FaceColor',[1 1 1],'EdgeColor', gc(1,:))
set(h(2),'FaceColor',gc(1,:),'EdgeColor', gc(1,:))
set(h(3),'FaceColor',[1 1 1],'EdgeColor', gc(5,:))
set(h(4),'FaceColor',gc(5,:),'EdgeColor', gc(5,:))

fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',7)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 8 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 5.png','-dpng','-r300','-painters');
%% Mean perceived urgency rate as a function of the beep rate for the four provided beep messages
figure('name','Figure 6','numbertitle','off');hold on % Confirmation of mode change
IBI=[1.97 1.16 0.70 0.44];  % inter-beep times; extracted with sound analysis
beep_duration = 0.22;
pause_between_pairs = 0.11;
beep_frequency = [0.396423380170022 0.58372856621671 0.800146693560486 1.01180438448567];
Xp=log10(beep_frequency);
Yp=log10(mean(X(:,38:41)));
fit_parameters = polyfit(Xp,Yp,1);
Xl=[min(Xp)-0.1*range(Xp) max(Xp)+0.1*range(Xp)];
Yl=polyval(fit_parameters,Xl);
disp('Slope of line')
disp(fit_parameters(1))
disp('Correlation coefficient')
disp(corr(Xp',Yp'))
plot(Xp,Yp,'ko','Markersize',8,'Linewidth',1,'Markerfacecolor','none')
plot(Xl,Yl,'--','color',gc(5,:),'Linewidth',1)
set(gca,'xtick',-10:.1:10)
set(gca,'ytick',-10:.1:10)
grid on
axis equal
xlabel('log_1_0 beep rate (Hz)','Fontsize',28,'Fontname','Arial')
ylabel('log_1_0 mean urgency rating (1 to 5)','Fontsize',28,'Fontname','Arial')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',9)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 4 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 6.png','-dpng','-r300','-painters');
%% Opinion of respondents on messages for take-over requests in the scenarios
M=[nansum(X(:,57)==1) nansum(X(:,57)==2) nansum(X(:,57)==3) nansum(X(:,57)==4) nansum(X(:,57)==5) nansum(X(:,57)==6) nansum(X(:,57)==7); % 1. construction works
    nansum(X(:,58)==1) nansum(X(:,58)==2) nansum(X(:,58)==3) nansum(X(:,58)==4) nansum(X(:,58)==5) nansum(X(:,58)==6) nansum(X(:,58)==7); % 2. construction works
    nansum(X(:,59)==1) nansum(X(:,59)==2) nansum(X(:,59)==3) nansum(X(:,59)==4) nansum(X(:,59)==5) nansum(X(:,59)==6) nansum(X(:,59)==7); % 3. exiting the highway
    nansum(X(:,60)==1) nansum(X(:,60)==2) nansum(X(:,60)==3) nansum(X(:,60)==4) nansum(X(:,60)==5) nansum(X(:,60)==6) nansum(X(:,60)==7); % 4. changing lanes
    nansum(X(:,61)==1) nansum(X(:,61)==2) nansum(X(:,61)==3) nansum(X(:,61)==4) nansum(X(:,61)==5) nansum(X(:,61)==6) nansum(X(:,61)==7); % 5. changing lanes
    nansum(X(:,62)==1) nansum(X(:,62)==2) nansum(X(:,62)==3) nansum(X(:,62)==4) nansum(X(:,62)==5) nansum(X(:,62)==6) nansum(X(:,62)==7); % 6. automation failure
    nansum(X(:,63)==1) nansum(X(:,63)==2) nansum(X(:,63)==3) nansum(X(:,63)==4) nansum(X(:,63)==5) nansum(X(:,63)==6) nansum(X(:,63)==7); % 7. accident
    nansum(X(:,64)==1) nansum(X(:,64)==2) nansum(X(:,64)==3) nansum(X(:,64)==4) nansum(X(:,64)==5) nansum(X(:,64)==6) nansum(X(:,64)==7)]'; % 8. accident
figure('name','Figure 7','numbertitle','off');hold on % Take-over request
barh(M(:,[3 4 1 6 7])/length(X));
Msort=M(:,[3 4 1 6 7]);

PCI=NaN(35,2);
for i=1:7
    [~, PCI(i,:)]=binofit(Msort(i),size(X,1));
    [~, PCI(i+size(M,1),:)]=binofit(Msort(i+size(M,1)),size(X,1));
    [~, PCI(i+2*size(M,1),:)]=binofit(Msort(i+2*size(M,1)),size(X,1));
    [~, PCI(i+3*size(M,1),:)]=binofit(Msort(i+3*size(M,1)),size(X,1));
    [~, PCI(i+4*size(M,1),:)]=binofit(Msort(i+4*size(M,1)),size(X,1));
    plot([PCI(i,1) PCI(i,2)], [i-.31 i-.31]','k')
    plot([PCI(i,1) PCI(i,1)], [i-.31+.05 i-.31-.05]','k')
    plot([PCI(i,2) PCI(i,2)], [i-.31+.05 i-.31-.05]','k')
    str=sprintf('%1.2f',Msort(i,1)./length(X));
    text(PCI(i,2)+ 0.007,i-.31,str,'fontsize',7,'fontname','arial')

    plot([PCI(i+size(M,1),1) PCI(i+size(M,1),2)], [i-.16 i-.16]','k')
    plot([PCI(i+size(M,1),1) PCI(i+size(M,1),1)], [i-.16+.05 i-.16-.05]','k')
    plot([PCI(i+size(M,1),2) PCI(i+size(M,1),2)], [i-.16+.05 i-.16-.05]','k')
    str=sprintf('%1.2f',Msort(i,2)./length(X));
    text(PCI(i+size(M,1),2)+ 0.007,i-.16,str,'fontsize',7,'fontname','arial')
    
    plot([PCI(i+2*size(M,1),1) PCI(i+2*size(M,1),2)], [i i]','k')
    plot([PCI(i+2*size(M,1),1) PCI(i+2*size(M,1),1)], [i+.05 i-.05]','k')
    plot([PCI(i+2*size(M,1),2) PCI(i+2*size(M,1),2)], [i+.05 i-.05]','k')
    str=sprintf('%1.2f',Msort(i,3)./length(X));
    text(PCI(i+2*size(M,1),2)+ 0.007,i,str,'fontsize',7,'fontname','arial')
    
    plot([PCI(i+3*size(M,1),1) PCI(i+3*size(M,1),2)], [i+.16 i+.16]','k')
    plot([PCI(i+3*size(M,1),1) PCI(i+3*size(M,1),1)], [i+.16+.05 i+.16-.05]','k')
    plot([PCI(i+3*size(M,1),2) PCI(i+3*size(M,1),2)], [i+.16+.05 i+.16-.05]','k')
    str=sprintf('%1.2f',Msort(i,4)./length(X));
    text(PCI(i+3*size(M,1),2)+ 0.007,i+.16,str,'fontsize',7,'fontname','arial')
    
    plot([PCI(i+4*size(M,1),1) PCI(i+4*size(M,1),2)], [i+.31 i+.31]','k')
    plot([PCI(i+4*size(M,1),1) PCI(i+4*size(M,1),1)], [i+.31+.05 i+.31-.05]','k')
    plot([PCI(i+4*size(M,1),2) PCI(i+4*size(M,1),2)], [i+.31+.05 i+.31-.05]','k')
    str=sprintf('%1.2f',Msort(i,5)./length(X));
    text(PCI(i+4*size(M,1),2)+ 0.007,i+.31,str,'fontsize',7,'fontname','arial')
end
set(gca,'ytick',1:7)
set(gca,'yticklabel',{'Sound', 'Vibrations', 'Visual', 'Sound and vibrations', 'Sound and visual', 'Visual and vibrations', 'Sound, visual, vibrations'})
xlabel('Proportion of respondents','Fontsize',28,'Fontname','Arial')
legend('ExitHighway', 'ChangeLanes', 'ConstWorks', 'Failure','Accident', 'Location', 'northeast')
set(gca,'ydir','reverse')
set(gca,'ylim',[.4 7.6],'xlim',[0 0.52])
colormap(gc([1 2 3 4 5],:));
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',7)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 6 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 7.png','-dpng','-r300','-painters');
%% Opinions of the respondents on messages for confirmation that the system is ready to switch back from the manual to the automated mode in the scenarios
figure('name','Figure 8 ','numbertitle','off');hold on % Confirmation of mode change
barh(M(:,[5 2 8])/length(X));
Msort=M(:,[5 2 8]);

PCI=NaN(21,2);
for i=1:7
    [~, PCI(i,:)]=binofit(Msort(i),size(X,1));
    [~, PCI(i+size(M,1),:)]=binofit(Msort(i+size(M,1)),size(X,1));
    [~, PCI(i+2*size(M,1),:)]=binofit(Msort(i+2*size(M,1)),size(X,1));
    
    plot([PCI(i,1) PCI(i,2)], [i-.22 i-.22]','k')
    plot([PCI(i,1) PCI(i,1)], [i-.22+.05 i-.22-.05]','k')
    plot([PCI(i,2) PCI(i,2)], [i-.22+.05 i-.22-.05]','k')
    str=sprintf('%1.2f',Msort(i,1)./length(X));
    text(PCI(i,2)+ 0.007,i-.22,str,'fontsize',7,'fontname','arial')

    
    plot([PCI(i+size(M,1),1) PCI(i+size(M,1),2)], [i i]','k')
    plot([PCI(i+size(M,1),1) PCI(i+size(M,1),1)], [i+.05 i-.05]','k')
    plot([PCI(i+size(M,1),2) PCI(i+size(M,1),2)], [i+.05 i-.05]','k')
    str=sprintf('%1.2f',Msort(i,2)./length(X));
    text(PCI(i+size(M,1),2)+ 0.007,i,str,'fontsize',7,'fontname','arial')
    
    plot([PCI(i+2*size(M,1),1) PCI(i+2*size(M,1),2)], [i+.22 i+.22]','k')
    plot([PCI(i+2*size(M,1),1) PCI(i+2*size(M,1),1)], [i+.22+.05 i+.22-.05]','k')
    plot([PCI(i+2*size(M,1),2) PCI(i+2*size(M,1),2)], [i+.22+.05 i+.22-.05]','k')
    str=sprintf('%1.2f',Msort(i,3)./length(X));
    text(PCI(i+2*size(M,1),2)+ 0.007,i+.22,str,'fontsize',7,'fontname','arial')
 end
set(gca,'ytick',1:7)
set(gca,'yticklabel',{'Sound', 'Vibrations', 'Visual', 'Sound and vibrations', 'Sound and visual', 'Visual and vibrations', 'Sound, visual, vibrations'})
xlabel('Proportion of respondents','Fontsize',28,'Fontname','Arial')
legend('ChangeLanes', 'ConstWorks', 'Accident','location','southeast')
set(gca,'ydir','reverse')
set(gca,'ylim',[.5 7.5],'xlim',[0 .43])
colormap(gc([2 3 5],:));
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',9)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 6 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 8.png','-dpng','-r300','-painters');
%% Urgency of long and very short beeps as a function of the gross domestic product (GPD) per capital
[GNI2,b]=sort(GNI);
XCms=XCm(b,:);
XCCIlowms=XCCIlowm(b,:);
XCCIhighms=XCCIhighm(b,:);
UCs=UC(b);
NCms=NCm(b);
%%
figure('name','Figure 9','numbertitle','off');hold on
for i=1:length(GNI2)
    hold on
    semilogx(GNI2(i),-1000+XCms(i,4),'s','MarkerFaceColor','r','MarkerEdgeColor','r','Markersize',3,'Linewidth',1)
    semilogx(GNI2(i),-1000+XCms(i,1),'o','MarkerFaceColor','k','MarkerEdgeColor','k','Markersize',3,'Linewidth',1)
    plot([GNI2(i) GNI2(i)],[XCms(i,1) XCms(i,4)],':','color',[.5 .5 .5])
    semilogx(GNI2(i),XCms(i,4),'s','MarkerFaceColor','r','MarkerEdgeColor','r','Markersize',3,'Linewidth',1)
    semilogx(GNI2(i),XCms(i,1),'o','MarkerFaceColor','k','MarkerEdgeColor','k','Markersize',3,'Linewidth',1)
    xlabel('GNI (US$, log scale)','FontSize',15)
    ylabel('Urgency (1=disagree strongly, 5=agree strongly)','FontSize',15)
    set(gca, 'xTickLabel',{'5000','10000','20000','50000'}, 'XTick', [5000 10000 20000 50000],'FontSize',15)
    set(gca,'xlim',[4000 60000])
    set(gca, 'XScale', 'log');
end
set(gca,'ylim',[1.4 4.9])
legend('Very short beeps','Long beeps','location','southwest')
% plot 96% CI
for i=1:length(XCms)
    plot([GNI2(i) GNI2(i)],[XCCIlowms(i,4) XCCIhighms(i,4)], 'r');
    plot([0.98*GNI2(i) 1.02*GNI2(i)],[XCCIlowms(i,4) XCCIlowms(i,4)], 'r');
    plot([0.98*GNI2(i) 1.02*GNI2(i)],[XCCIhighms(i,4) XCCIhighms(i,4)], 'r');
    plot([GNI2(i) GNI2(i)],[XCCIlowms(i,1) XCCIhighms(i,1)], 'k');
    plot([0.98*GNI2(i) 1.02*GNI2(i)],[XCCIlowms(i,1) XCCIlowms(i,1)], 'k');
    plot([0.98*GNI2(i) 1.02*GNI2(i)],[XCCIhighms(i,1) XCCIhighms(i,1)], 'k');
end
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',7)
for i=1:2:length(GNI2)
    text(GNI2(i),XCCIlowms(i,1)-.05,UCs(i),'HorizontalAlignment','center','FontSize',5,'color',gc(1,:))
    text(GNI2(i),XCCIlowms(i,1)-.12,num2str(NCms(i)),'HorizontalAlignment','center','FontSize',5,'color','k')
end
for i=2:2:length(GNI2)
    text(GNI2(i),XCCIhighms(i,4)+.05,UCs(i),'HorizontalAlignment','center','FontSize',5,'color',gc(1,:))
    text(GNI2(i),XCCIhighms(i,4)+.12,num2str(NCms(i)),'HorizontalAlignment','center','FontSize',5,'color','k')
end
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
set(gcf, 'PaperPosition', [0 0 8 4]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches');
print(gcf,'Figure 9.png','-dpng','-r300','-painters');